//////////////////////////////////////////////////////////////////////////////
//                      Copyright (c) 2005 Gerhard Schalk
//
//                      80C537A Mikrocontroller Training
//                              C Programmierung
//
//////////////////////////////////////////////////////////////////////////////
//   Projekt:       80C537A ADC  
//
//   Filename:      ADC.C
////////////////////////////////////////////////////////////////////////////// 
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <reg517a.h>


//-------------------------------------------------------------------------
//  Funktion: int ReadADC(char Channel)
//-------------------------------------------------------------------------
int ReadADC(char Channel)
{
	ADCON1=Channel;
	ADDATL = 0;
	while(BSY);
	return((ADDATL>>6)+ADDATH*4);
}


#if 0
//-------------------------------------------------------------------------
//  Funktion: float ReadADCVolt(char Channel)
//-------------------------------------------------------------------------
float ReadADCVolt(char Channel)
{
	return (5.0* ReadADC(Channel))/1024.0;
}
#endif


//-------------------------------------------------------------------------
//  Funktion: float ReadADCTemp(void)
//-------------------------------------------------------------------------
float ReadADCTemp(void)
{
	float r_temp,lnr,temp;

	code float a=0.0012814814,
	   		   b=0.000236678791,
          	   c=0.0000000908736406,
          	   r_ref = 4990;
	int adu;
	
	adu = ReadADC(8);

	r_temp = r_ref*adu/(1023-adu);

	lnr = log(r_temp);

	temp = (1.0/(a+b*lnr+c*lnr*lnr*lnr));
	
	temp-=273.2;
	
	return temp;
}

