//////////////////////////////////////////////////////////////////////////////
//                      Copyright (c) 2005 Gerhard Schalk
//
//                      80C537A Mikrocontroller Training
//                              C Programmierung
//
//////////////////////////////////////////////////////////////////////////////
//   Projekt:       RTC Watch
//
//   Filename:      RTCWatch.C
//////////////////////////////////////////////////////////////////////////////   

//-------------------------------------------------------------------------
//  Include Dateien
//-------------------------------------------------------------------------
#include <stdio.h>          // Standard I/O Funktionen
#include <80C517.H>
#include "REG517A.H"
#include "lcd.h"            // LCD Funktionen 
#include "RTC_PCF8563.H"
#include "RTCWatch.H"


//--------------------------------------------------------------------------
// Funktion: void DisplayRTC(char zeile, char spalte)
//--------------------------------------------------------------------------
void DisplayWatch(char zeile, char spalte)
{   
    unsigned char lcdtext[21];
    struct time Zeit;

    // Akuelle Uhrzeit vom RTC PCF8563 auslesen 
    ReadRTCTime(&Zeit);

    sprintf517(lcdtext,"%b02X:%b02X:%b02X",Zeit.hour,Zeit.min,Zeit.sec);    
    print_lcd(zeile,spalte,lcdtext);
}

//--------------------------------------------------------------------------
// Funktion: void SetRTC(char zeile, char spalte)
//--------------------------------------------------------------------------
void SetWatch(char zeile, char spalte)
{   
    unsigned char lcdtext[21];
    unsigned char i;
    struct time SetTime;

    DisplayWatch(zeile, spalte);

    sprintf517(lcdtext," TMP  DS  NTC  UHR* ");
    print_lcd(2,1,lcdtext);     // Ausgabe auf LCD Display Zeile 2
    
    

    for(i=0;i<4;i++)
    {   
       CursorBlinkOnOff(zeile,spalte,ON);

       while(KeySignal);    // Warten bis Taste gedrueckt wurde
       while(KeySignal==0);  // Warten bis Taste wieder losgelassen wurde   

       switch(i)
       {
           case 0:  SetTime.hour = KeyValue;
                    sprintf517(lcdtext,"%bx",KeyValue);
                    print_lcd(zeile,spalte,lcdtext);
                    spalte ++;
                    break;
    
           case 1:  SetTime.hour <<=4;
                    SetTime.hour |= KeyValue;
                    sprintf517(lcdtext,"%bx",KeyValue);
                    print_lcd(zeile, spalte, lcdtext);
                    spalte += 2;
                    break;
    
           case 2:  SetTime.min = KeyValue;
                    sprintf517(lcdtext,"%bx",KeyValue);
                    print_lcd(zeile, spalte, lcdtext);
                    spalte ++;
                    break;
    
           case 3:  SetTime.min <<=4;
                    SetTime.min |= KeyValue; 
                    sprintf517(lcdtext,"%bx",KeyValue);
                    print_lcd(zeile, spalte, lcdtext);
                    break;
       } 
    }
    
    SetTime.sec = 0;
    SetRTCTime(&SetTime);
    DisplayWatch(zeile, spalte);
    CursorBlinkOnOff(1,1,OFF);
}



