//////////////////////////////////////////////////////////////////////////////
//                      Copyright (c) 2005 Gerhard Schalk
//
//                      80C537A Mikrocontroller Training
//                              C Programmierung
//
//////////////////////////////////////////////////////////////////////////////
//   Header File:   I2C
//////////////////////////////////////////////////////////////////////////////  
#ifndef __I2C_H_INCLUDED
#define __I2C_H_INCLUDED

    //--------------------------------------------------------------------------
    // I2C Hardware I/O Port Defines
    //--------------------------------------------------------------------------
    sbit        SDA = P3^4;
    sbit        SCL = P3^5;
    #define     HIGH	1         	
    #define		LOW		0	    

    #define     DelayNormalMode  2
    #define     DelayFastMode    0

    //--------------------------------------------------------------------------
    
    
    //--------------------------------------------------------------------------
    // I2C Funktionen
    //--------------------------------------------------------------------------
    void i2c_Start (void);	// Senden der I2C Start Condition
    void i2c_Stop  (void);	// Senden der I2C Stop Condition
    unsigned char i2c_MasterWrite(unsigned char output_data);	//I2C Datenbyte Senden
    unsigned char i2c_MasterRead(bit ACKValue); //I2C Datenbyte Lesen				        

#endif
