//////////////////////////////////////////////////////////////////////////////
//                      Copyright (c) 2005 Gerhard Schalk
//
//                      80C537A Mikrocontroller Training
//                              C Programmierung
//
//////////////////////////////////////////////////////////////////////////////
//   Projekt:       Drehimpulsgeber
//                 
//   Filename:      Drehgeber.C
////////////////////////////////////////////////////////////////////////////// 
#include <reg517a.h>


unsigned char OldValue;

//-------------------------------------------------------------------------
//  void init_Drehimpulsgeber (void)
//-------------------------------------------------------------------------
void init_Drehimpulsgeber (void)
{
    P1 |=0x19;
    OldValue = P1 & 0x11;
}

//-------------------------------------------------------------------------
//  Funktion: unsigned char Drehimpulsgeber (unsigned char Wert)
//  Bei Rechtsdrehung wird Wert erhht und bei Linksdrehung erniedrigt.
//-------------------------------------------------------------------------
unsigned char Drehimpulsgeber (unsigned char Wert)
{   
    unsigned char ActValue;

    ActValue = P1 & 0x11;  //P1.0/P1.4 (Richtung B/A) 
    if(ActValue != OldValue)
    {
        switch(OldValue)
        {
            case 0x00:
                if(ActValue == 0x10) Wert--;
                if(ActValue == 0x01) Wert++;
                break;

            case 0x01:
                if(ActValue == 0x00) Wert--;
                if(ActValue == 0x11) Wert++;
                break;

            case 0x10:
                if(ActValue == 0x11) Wert--;
                if(ActValue == 0x00) Wert++;
                break;

            case 0x11:
                if(ActValue == 0x01) Wert--;
                if(ActValue == 0x10) Wert++;
                break;
        }
        OldValue = ActValue;
        return Wert;
    }
}


