//////////////////////////////////////////////////////////////////////////////
//                      Copyright (c) 2005 Gerhard Schalk
//
//                      80C537A Mikrocontroller Training
//                              C Programmierung
//
//////////////////////////////////////////////////////////////////////////////
//   Projekt:       Temperaturmessungen und Ausgabe auf LCD-Anzeige fuer:
//                  TMP100, DS1822 und NTC
//
//   Filename:      DS1822.C
//////////////////////////////////////////////////////////////////////////////   

//-------------------------------------------------------------------------
//  Include Dateien
//-------------------------------------------------------------------------
#include <stdio.h>              // Standard I/O Funktionen
#include <80C517.H>
#include "REG517A.H"
#include "lcd.h"                // LCD Funktionen 
#include "TempSensor_TMP100.H"
#include "DS1822.H"
#include "ADC.H"
    


//--------------------------------------------------------------------------
// Funktion: void MeasureTMP100(void)
//--------------------------------------------------------------------------
void MeasureTMP100(void)
{   unsigned char lcdtext[21];
    float TMP100_TempValue;
    char Error;

    // Akuelle Temp. vom TMP100 Sensor auslesen               
    Error =  ReadTempTMP100(&TMP100_TempValue);            
    if(Error)
    { 
        sprintf517(lcdtext,"TMP100: Error");    
    }
    else
    {
        sprintf517(lcdtext,"1: %+3.2fC",TMP100_TempValue);    
    } 
    print_lcd(1,1,lcdtext);
 
    sprintf517(lcdtext," TMP* DS  NTC  UHR ");
    print_lcd(2,1,lcdtext);  
}

//--------------------------------------------------------------------------
// Funktion: void MeasureDS1822(void)
//--------------------------------------------------------------------------
void MeasureDS1822(void)
{
    unsigned char lcdtext[21];
    float DS1822_TempValue;
    char Error;

    Error = DS1822ReadTemp(&DS1822_TempValue); // Akuelle Temp. vom DS1822 Sensor lesen
    if(Error)
    {
      sprintf517(lcdtext,"DS1820:Error");    
    }
    else
    {
        sprintf517(lcdtext,"2: %+3.2fC",DS1822_TempValue);    
    } 
    print_lcd(1,1,lcdtext);                 // Ausgabe auf LCD Display Zeile 1

    sprintf517(lcdtext," TMP  DS* NTC  UHR ");
    print_lcd(2,1,lcdtext);                 // Ausgabe auf LCD Display Zeile 2
}

//--------------------------------------------------------------------------
// Funktion: void MeasureNTC(void)
//--------------------------------------------------------------------------
void MeasureNTC(void)
{
    unsigned char lcdtext[21];
    float NTC_TempValue;

    NTC_TempValue = ReadADCTemp();

    sprintf517(lcdtext,"3: %+3.2fC",NTC_TempValue);    
    print_lcd(1,1,lcdtext);                 // Ausgabe auf LCD Display Zeile 1

    sprintf517(lcdtext," TMP  DS  NTC* UHR ");
    print_lcd(2,1,lcdtext);                 // Ausgabe auf LCD Display Zeile 2
}


